Loading...
Searching...
No Matches
casacore::BucketBase Class Referenceabstract
casa package (libcasa_casa) » IO_module » IO_module_internal_classes

More...

`#include <BucketBase.h>`

## Public Member Functions

| BucketBase (BucketFile *file, Int64 startOffset, uInt bucketSize, uInt nrOfBuckets)
| Create the bucket access for (part of) a file.
virtual | ~BucketBase ()
| Detach the file.
Bool | flush ()
| Flush the cached buckets.
virtual void | resync (uInt nrBucket)
| Resynchronize the object (after another process updated the file).
uInt | nBucket () const
| Get the current nr of buckets in the file.
void | extend (uInt nrBucket)
| Extend the file with the given number of buckets.
void | setWritten ()
| Set that data has been written.

## Protected Member Functions

| BucketBase (const BucketBase &)
| Copy constructor is not possible.
BucketBase & | operator= (const BucketBase &)
| Assignment is not possible.
virtual void | doFlush ()=0
| Do the actual flushing.
virtual void | doResync ()=0
| Do the actual resync-ing.
virtual void | doExtend (uInt nrBucket)=0
| Do the actual extension of the file.
virtual void | initializeBuckets (uInt bucketNr)=0
| Initialize the bucket buffer.

## Protected Attributes

BucketFile * | itsFile
| The file used.
Int64 | itsStartOffset
| The starting offsets of the buckets in the file.
uInt | itsBucketSize
| The bucket size.
uInt | itsCurNrOfBuckets
| The current nr of buckets in the file.
uInt | itsNewNrOfBuckets
| The new nr of buckets in the file (after extension).
Bool | itsHasWritten
| Have data been written?

## Detailed Description

Abstract base class for Bucket classes.

### Intended use:

Internal

### Review Status

Reviewed By:
  UNKNOWN
Date Reviewed:
  before2004/08/25

### Prerequisite

- BucketFile

### Synopsis

BucketBase is the abstract baseclass for the various Bucket classes like BucketMapped and BucketBuffered. It is used by TSMCube to do the IO in the required way.

Definition at line 57 of file BucketBase.h.

## Constructor & Destructor Documentation

## BucketBase() [1/2]

casacore::BucketBase::BucketBase | ( | BucketFile * | file,
|  | Int64 | startOffset,
|  | uInt | bucketSize,
|  | uInt | nrOfBuckets )

Create the bucket access for (part of) a file.

The file part starts at startOffset. Its length is bucketSize*nrOfBuckets bytes. If the file is smaller, the remainder is indicated as an extension similarly to the behaviour of function extend.

Referenced by BucketBase(), and operator=().

## ~BucketBase()

virtual casacore::BucketBase::~BucketBase | ( |  | ) |

virtual

Detach the file.

The BucketFile is not closed.

## BucketBase() [2/2]

casacore::BucketBase::BucketBase | ( | const BucketBase & |  | ) |

protected

Copy constructor is not possible.

References BucketBase().

## Member Function Documentation

## doExtend()

virtual void casacore::BucketBase::doExtend | ( | uInt | nrBucket | ) |

protected pure virtual

Do the actual extension of the file.

Note that itsNewNrOfBuckets has been increased before doExtend is called.

Implemented in casacore::BucketBuffered, and casacore::BucketMapped.

## doFlush()

virtual void casacore::BucketBase::doFlush | ( |  | ) |

protected pure virtual

Do the actual flushing.

Implemented in casacore::BucketBuffered, and casacore::BucketMapped.

## doResync()

virtual void casacore::BucketBase::doResync | ( |  | ) |

protected pure virtual

Do the actual resync-ing.

Implemented in casacore::BucketBuffered, and casacore::BucketMapped.

## extend()

void casacore::BucketBase::extend | ( | uInt | nrBucket | ) |

Extend the file with the given number of buckets.

The buckets get initialized when they are acquired (using getBucket) for the first time.

## flush()

Bool casacore::BucketBase::flush | ( |  | ) |

Flush the cached buckets.

Possibly remaining uninitialized buckets will be initialized first. A True status is returned if buckets had to be written. The actual flushing is done using doFlush in the derived class.

## initializeBuckets()

virtual void casacore::BucketBase::initializeBuckets | ( | uInt | bucketNr | ) |

protected pure virtual

Initialize the bucket buffer.

The uninitialized buckets before this bucket are also initialized.

Implemented in casacore::BucketBuffered, and casacore::BucketMapped.

## nBucket()

uInt casacore::BucketBase::nBucket | ( |  | ) | const

inline

Get the current nr of buckets in the file.

Definition at line 84 of file BucketBase.h.

References itsCurNrOfBuckets.

## operator=()

BucketBase & casacore::BucketBase::operator= | ( | const BucketBase & |  | ) |

protected

Assignment is not possible.

References BucketBase().

## resync()

virtual void casacore::BucketBase::resync | ( | uInt | nrBucket | ) |

virtual

Resynchronize the object (after another process updated the file).

It remaps the file if the nr of buckets has changed. the new sizes.

## setWritten()

void casacore::BucketBase::setWritten | ( |  | ) |

inline

Set that data has been written.

Definition at line 93 of file BucketBase.h.

References itsHasWritten, and casacore::True.

## Member Data Documentation

## itsBucketSize

uInt casacore::BucketBase::itsBucketSize

protected

The bucket size.

Definition at line 123 of file BucketBase.h.

## itsCurNrOfBuckets

uInt casacore::BucketBase::itsCurNrOfBuckets

protected

The current nr of buckets in the file.

Definition at line 125 of file BucketBase.h.

Referenced by nBucket().

## itsFile

BucketFile* casacore::BucketBase::itsFile

protected

The file used.

Definition at line 119 of file BucketBase.h.

## itsHasWritten

Bool casacore::BucketBase::itsHasWritten

protected

Have data been written?

Definition at line 129 of file BucketBase.h.

Referenced by casacore::BucketMapped::getrwBucket(), and setWritten().

## itsNewNrOfBuckets

uInt casacore::BucketBase::itsNewNrOfBuckets

protected

The new nr of buckets in the file (after extension).

Definition at line 127 of file BucketBase.h.

## itsStartOffset

Int64 casacore::BucketBase::itsStartOffset

protected

The starting offsets of the buckets in the file.

Definition at line 121 of file BucketBase.h.

The documentation for this class was generated from the following file:

- casa/IO/BucketBase.h